---
title: Operating personal AS
date: 2024-07-17T01:11:00.000Z
slug: operating-personal-as
---
### AS214578

I am operating small network of AS214578, with few IPv6 spaces only.

I acquired AS and Addresses from RIPE, which is relatively easy to work with.\
It costs about 100EUR/year for ASN and 80EUR/yr for /44 IPv6 Addresses.

I only breifly knew about how internet routing works, then I got curious about details few years ago.\
I found few of my colleages got their own AS for them to play with, so I decided to do so.

Unlike other RIR (afaik), RIPE has unique heirachy called LIR. Its like smaller distributor for RIPE resources.\
We can contact LIR for them to sponsor my ASN and IP spaces.\
We also can directly acquire resources from RIPE, but it requires to be member of RIPE which costs few thousands per year.

We can request IP resources seperately from who sponsors ASN.\
I can get ASN from some provider who provides it at cheap, and IPv6 from other provider who provides at cheap.



**Internet Exchange** a point where many ASes get together to connect their servers to exchange traffic between each other. Sometimes IX itself routes and makes announcements for their peers.
Sometimes IX itself has a route server to announce and distribute routes to its peers effectively.
There are non-commercial and virtual IXs that accept connections from remote servers via GRE or VXLAN.


**Anycast** enables multiple servers in different geographical locations to share the same IP address. This is often used for CDN purposes to serve content locally. Client connects one of route, destined to one specific server depends on what route they use.


**Peering** exchange traffic between their networks directly. Peering makes direct route for each others networks.
**Transit** refers to the service where one network provides another network access to all other networks that it can reach. It provides upstream for clients for them to reach "internet" and "internet" the gateway to reach customer's network. Transit providers charge fees to access their full routing table and gateway services.
There is also free transit services for single use networks and personal networks, but it usually has long routes and small capacity.
